#include <stdio.h>
#include <stdlib.h>

int f(char ulaz[], int *ucitanih_znakova, int duljine[]) {
  /* indeks trenutnog bloka, da znamo gdje pisati u polju duljine */
  int blok = 0;

  /* ucitavamo znakove */
  int i = 0;
  do
  {
    scanf("%c", &ulaz[i]);
    ++i;
  } while (ulaz[i - 1] != '%');

  *ucitanih_znakova = i;

  /* u nastavku i koristimo za citanje polja znak-po-znak */
  i = 0;

  /* ova petlja prolazi blokovima */
  while (ulaz[i] != '%')
  {
    /* unutar pojedinog bloka pamtimo u kojoj smo fazi citanja
     *  0: citamo pocetni [AB]{0, 20} dio
     *  1: citamo prvi znak iz [CD]+
     *  2: citamo ostatak iz [CD]+
     *  3: citamo prvi znak iz [AB]+
     *  4: citamo ostatak iz [AB]+
     *  5: citamo C
     */
    int faza = 0;

    /* kasnije moramo znati koliko smo znakova procitali unutar bloka */
    int pocetak_bloka = i;

    /* pretpostavimo da regularni izraz ne prihvaca ovaj blok */
    int prihvaca = 0;

    /* koliko je znakova u [AB]{0, 20} */
    int dulj_AB = 0;

    /* ovdje pamtimo indeks na kojem zavrsava (trenutni) najdulji dobar prefiks */
    int max_prefiks = -1;

    /* ova petlja prolazi znakovima unutar bloka */
    while (ulaz[i] != '%' && ulaz[i] != '-')
    {
      if (faza == 0)
      {
        if (ulaz[i] == 'A' || ulaz[i] == 'B')
        {
          ++dulj_AB;
          if (dulj_AB == 20)
            faza = 1;

          ++i;
        }
        else
          faza = 1;
      }
      else if (faza == 1)
      {
        if (ulaz[i] != 'C' && ulaz[i] != 'D')
          break;

        max_prefiks = i;
        faza = 2;
        ++i;
      }
      else if (faza == 2)
      {
        if (ulaz[i] == 'C' || ulaz[i] == 'D') {
          max_prefiks = i;
          ++i;
        }
        else
          faza = 3;
      }
      else if (faza == 3)
      {
        if (ulaz[i] != 'A' && ulaz[i] != 'B')
          break;

        faza = 4;
        ++i;
      }
      else if (faza == 4)
      {
        if (ulaz[i] == 'A' || ulaz[i] == 'B') {
          ++i;
        }
        else
          faza = 5;
      }
      else {
        if (ulaz[i] != 'C')
          break;

        max_prefiks = i;
        faza = 3;
        ++i;
      }
    }

    duljine[blok] = max_prefiks == -1 ? -1 : max_prefiks - pocetak_bloka + 1;

    ++blok;
    
    /* pomak na sljedeci blok */
    while (ulaz[i] != '-' && ulaz[i] != '%')
      ++i;
    if (ulaz[i] == '-')
      ++i;
  }

  return blok;
}

/* test, nije dio rjesenja */
int main(void) {
  int n;

  char ulaz[100];
  int duljine[100];
  int blokova = f(ulaz, &n, duljine);

  int i;
  for (i = 0; i < blokova; ++i)
    printf("%d\n", duljine[i]);
  
  return 0;
}

