#include <stdio.h>
#include <stdlib.h>

int d(int x)
{
  int n = 0;
  while (x > 0)
  {
    x /= 10;
    ++n;
  }
  return n;
}

int zn(int x, int i)
{
  for (; i > 0; --i)
    x /= 10;
  return x % 10;
}

int lijep(int x)
{
  int i = 0;

  int duljina = d(x);

  /* broj moze biti lijep na dva nacina, pretpostavimo da je lijep na oba */
  int lijep_xyxy = 1, lijep_xyyx = 1;

  for (i = 0; i < duljina / 2; ++i) {
    /* usporedimo svaku znamenku u prvoj polovici s odgovarajucom u drugoj polovici */
    lijep_xyxy = lijep_xyxy && zn(x, i) == zn(x, i + duljina / 2);
    lijep_xyyx = lijep_xyyx && zn(x, i) == zn(x, duljina - i - 1);
  }

  return lijep_xyxy || lijep_xyyx;
}

int b(int x)
{
  int udaljenost;

  /* nema lijepog broja manjeg od 11, znamo da x >= 10, pa samo slucaj x == 10 treba posebno obraditi */
  if (x == 10)
    return 1;

  /* jedan nacin je traziti prvi lijep broj, u oba smjera */
  for (udaljenost = 0; x - udaljenost >= 11; ++udaljenost)
    if (d(x - udaljenost) % 2 == 0 && lijep(x - udaljenost) ||
        d(x + udaljenost) % 2 == 0 && lijep(x + udaljenost))   
        return udaljenost;
}

void sort(int a[], int n) {
  int i, j;
  for (i = 0; i < n - 1; ++i)
    for (j = i + 1; j < n; ++j)
      if (b(a[i]) > b(a[j])  ||  b(a[i]) == b(a[j]) && a[i] > a[j])
      {
        int t = a[i];
        a[i] = a[j];
        a[j] = t;
      }
}

/* test, nije dio rjesenja */
int main(void) {

  int polje[] = {101050, 101020, 56, 14622641, 54, 58, 50, 10100600, 101, 123 };
  sort(polje, sizeof(polje) / sizeof(int));
  int i;
  for (i = 0; i < sizeof(polje) / sizeof(int); ++i)
      printf("%d\t%d\t%d\n", i, b(polje[i]), polje[i]);

  return 0;
}

